//
//	test EncircledEnergyDataServer
//
#include <iostream>

#include "common.h"
#include "CalServer.h"
//#include "EncircledEnergyDataServer.h"
#include "PsfDataServer.h"
#include "Xmm.h"

using namespace std;

int main(int argc, char **argv)
{
#if 0
	calServer.setInstrument(Xmm::EPN);
	EncircledEnergyDataServer *eds = 0; eds = calServer.getAtom(eds);
	double emin = eds->eValidity().lo();
	const EncircledEnergyFunction &eefunc = eds->encircledEnergy(emin);
	for (double r=0.1; r<=25.; r+=.1)
		cout<<"EE("<<r<<"\")="<<eefunc(r)<<endl;
#endif

	if (argc == 2)
		calServer.ccf()->registerNewCifEntry(argv[1]);

// Test the ELLIPTICAL mode
       
	calServer.setInstrument(Xmm::EMOS2);
	calServer.state()->accuracyLevel()->set(ELLBETA);
	PsfDataServer *pds2 = 0; pds2 = calServer.getAtom(pds2);

    // Loop over energies from 10 to 15000 eV
        for (int i=1; i<1600; i++) {
           double energy=10.0*i;
   	   const Psf &psf2 = pds2->psf(energy,0.0,0.0);
   	   //const Psf &psf2 = pds2->psf(energy,720.0,0.0);
   	   //const Psf &psf2 = pds2->psf(1500.0,i,0.0);

    	    cout<<"EN: "<<energy<<" "<<psf2.encircledEnergy(0.72674)<<endl;  // 20 arcsec circle
        }

	return 0;
}
