//
//	test the AbsorptionDataServer class
//
#include <iostream>
#include <cassert>
#include "CalServer.h"
#include "Ccf.h"
#include "FWCDataServer.h"

using namespace std;

/*
namespace {
bool isClose(double a, double b)
{
    return fabs(a)/fabs(b)-1. < 1.e-5;
}
}
*/

int main()
{
	//	setup the the Cal server
	const Xmm::Instrument instrument = Xmm::EMOS1;
	calServer.setInstrument(instrument);
	calServer.state()->ccd()->set(1);

	//	get the FWCDataServer
	FWCDataServer *fds = 0; fds = calServer.getAtom(fds);

        // Read in the expos time v rev structure
        FWCexptime exp = fds->exptime();

        cout<<"exp [0] "<<exp.rev[0]
            <<" tstart: "<<exp.tstart[0]
            <<" tstop: "<<exp.tstop[0]
            <<" expos: "<<exp.exptime[0]
            <<" ccd: "<<exp.ccd[0]
            <<" nflag: "<<exp.nflag[0]<<endl;

        // Get events for a set of Rev,ccd pairs
        multimap<int, unsigned> revCcd;
        revCcd.insert(make_pair(230,1));
        revCcd.insert(make_pair(230,2));
        vector<FWCevent> fev = fds->getEvents(revCcd);

        cout<<"Number of rows: "<<fev.size()<<endl;

        cout<<"Event 1: "<<fev[0].flag()<<" "<<fev[0].pi()<<endl;
        cout<<"Event 1: "<<fev[0].pattern()<<" "<<fev[0].weight()<<endl;
        cout<<"Event 2: "<<fev[1].rawx()<<" "<<fev[1].rawy()<<endl;
        cout<<"Event 2: "<<fev[1].detx()<<" "<<fev[1].dety()<<endl;
        cout<<"Event 3: "<<fev[2].time()<<" "<<fev[2].ccd()<<endl;
        cout<<"Event 3: "<<fev[2].rev()<<endl;

	return 0;
}







